function g3 = static_g3(T, y, x, params, T_flag)
% function g3 = static_g3(T, y, x, params, T_flag)
%
% File created by Dynare Preprocessor from .mod file
%
% Inputs:
%   T         [#temp variables by 1]  double   vector of temporary terms to be filled by function
%   y         [M_.endo_nbr by 1]      double   vector of endogenous variables in declaration order
%   x         [M_.exo_nbr by 1]       double   vector of exogenous variables in declaration order
%   params    [M_.param_nbr by 1]     double   vector of parameter values in declaration order
%                                              to evaluate the model
%   T_flag    boolean                 boolean  flag saying whether or not to calculate temporary terms
%
% Output:
%   g3
%

if T_flag
    T = HANK_q4.objective.static_g3_tt(T, y, x, params);
end
v3 = zeros(2,3);
v3(1,1)=1;
v3(2,1)=1;
v3(1,2)=1883764;
v3(2,2)=2302378;
v3(1,3)=(y(10)+y(10))/(y(10)*y(10)*y(10)*y(10));
v3(2,3)=(-(params(11)*getPowerDeriv(y(12),1+params(10),3)/(1+params(10))));
g3 = sparse(v3(:,1),v3(:,2),v3(:,3),1,95443993);
end
