function g1 = static_g1(T, y, x, params, T_flag)
% function g1 = static_g1(T, y, x, params, T_flag)
%
% File created by Dynare Preprocessor from .mod file
%
% Inputs:
%   T         [#temp variables by 1]  double   vector of temporary terms to be filled by function
%   y         [M_.endo_nbr by 1]      double   vector of endogenous variables in declaration order
%   x         [M_.exo_nbr by 1]       double   vector of exogenous variables in declaration order
%   params    [M_.param_nbr by 1]     double   vector of parameter values in declaration order
%                                              to evaluate the model
%   T_flag    boolean                 boolean  flag saying whether or not to calculate temporary terms
%
% Output:
%   g1
%

if T_flag
    T = RANK_q4.static_g1_tt(T, y, x, params);
end
g1 = zeros(39, 39);
g1(1,22)=1;
g1(1,26)=1;
g1(2,9)=y(31)*params(15);
g1(2,15)=y(30);
g1(2,17)=y(30)*(-params(19));
g1(2,27)=(-1);
g1(2,28)=(-1);
g1(2,29)=1;
g1(2,30)=y(15)-1-(y(17)-params(3))*params(19);
g1(2,31)=params(15)*y(9);
g1(3,3)=params(23)*y(22)*(-(y(18)*T(1)*(1-params(5))*params(21)*T(2)*getPowerDeriv(y(3),params(5),2)))+params(23)*y(23)*(-(params(22)*y(18)*T(5)*T(2)*params(5)*params(21)*getPowerDeriv(y(3),params(5)-1,2)))+params(23)*y(32)*(-(T(5)*params(21)*y(11)*y(11)*T(33)));
g1(3,5)=params(23)*y(22)*(-(y(18)*T(4)*T(18)))+params(23)*y(23)*(-(params(22)*y(18)*T(7)*T(14)))+params(23)*y(32)*(-(params(21)*y(11)*T(9)*T(14)));
g1(3,11)=params(23)*y(22)*(-(y(18)*T(1)*T(3)*(1-params(5))*params(21)*T(23)))+params(23)*y(23)*(-(params(22)*y(18)*T(5)*T(6)*params(5)*params(21)*T(23)))+params(23)*y(32)*(-(T(5)*params(21)*(T(9)+y(11)*y(3)*T(33))));
g1(3,15)=params(23)*y(33)*(-y(17));
g1(3,16)=params(23)*y(33)*(-(1/params(22)-1));
g1(3,17)=params(23)*y(24)*(-params(8))+params(23)*y(25)*T(28)+params(23)*y(33)*(-T(29))+params(23)*y(35)*(-(params(8)*(-T(28))));
g1(3,18)=params(23)*y(22)*(-(T(1)*T(4)))+params(23)*y(23)*(-(params(22)*T(5)*T(7)));
g1(3,22)=params(23)*(-(y(18)*T(1)*T(4)));
g1(3,23)=params(23)*(-(params(22)*y(18)*T(5)*T(7)));
g1(3,24)=1+params(23)*(-(1+(y(17)-params(3))*params(8)));
g1(3,25)=params(23)*(y(17)+T(8));
g1(3,32)=params(23)*(-(T(5)*params(21)*y(11)*T(9)));
g1(3,33)=params(23)*T(10);
g1(3,35)=params(23)*(-(params(8)*(-(y(17)+T(8)))));
g1(4,4)=(-1)/(y(4)*y(4))+y(28)*(params(8)*y(4)*params(8)*y(4)*(-params(8))-(-(params(8)*y(4)))*(params(8)*params(8)*y(4)+params(8)*params(8)*y(4)))/(params(8)*y(4)*params(8)*y(4)*params(8)*y(4)*params(8)*y(4))+T(12)*y(28)*(-params(8))/(params(8)*y(4)*params(8)*y(4));
g1(4,5)=y(26)*(-T(15));
g1(4,25)=1;
g1(4,26)=(-T(11));
g1(4,28)=(-(params(8)*y(4)))/(params(8)*y(4)*params(8)*y(4))+T(12)*1/(params(8)*y(4));
g1(4,35)=params(8);
g1(5,3)=y(32)*(-(params(21)*y(11)*T(9)*T(14)))+y(23)*(-(params(22)*y(18)*T(7)*T(14)))+y(22)*(-(y(18)*T(4)*T(18)));
g1(5,4)=y(26)*(-T(15));
g1(5,5)=y(32)*(-(T(13)*T(34)))+y(26)*(-(y(4)*params(11)*getPowerDeriv(y(5),params(10),2)))+y(23)*(-(params(22)*y(18)*T(2)*params(5)*params(21)*T(16)*T(34)))+y(22)*(-(y(18)*(1-params(5))*params(21)*T(2)*T(17)*getPowerDeriv(y(5),(-params(5)),2)))-params(11)*getPowerDeriv(y(5),1+params(10),2)/(1+params(10));
g1(5,11)=T(35);
g1(5,18)=y(23)*(-(params(22)*T(14)*T(2)*params(5)*params(21)*T(16)))+y(22)*(-((1-params(5))*params(21)*T(2)*T(17)*T(18)));
g1(5,22)=(-(y(18)*(1-params(5))*params(21)*T(2)*T(17)*T(18)));
g1(5,23)=(-(params(22)*y(18)*T(14)*T(2)*params(5)*params(21)*T(16)));
g1(5,26)=(-(y(4)*T(15)));
g1(5,32)=(-(T(13)*T(14)));
g1(6,27)=1;
g1(7,7)=y(31)*params(15)*y(9)*(-((params(8)*y(7)*params(8)*y(7)*(-params(8))-(-(params(8)*y(7)))*(params(8)*params(8)*y(7)+params(8)*params(8)*y(7)))/(params(8)*y(7)*params(8)*y(7)*params(8)*y(7)*params(8)*y(7))))+T(12)*y(31)*params(15)*y(9)*(-((-params(8))/(params(8)*y(7)*params(8)*y(7))));
g1(7,9)=y(35)*(-(params(8)*(-T(21))))+y(33)*T(21)+y(25)*T(21)+y(31)*params(15)*(-((-(params(8)*y(7)))/(params(8)*y(7)*params(8)*y(7))))+T(12)*y(31)*params(15)*(-(1/(params(8)*y(7))));
g1(7,18)=y(33);
g1(7,25)=(-(1-T(19)));
g1(7,31)=params(15)*y(9)*(-((-(params(8)*y(7)))/(params(8)*y(7)*params(8)*y(7))))+T(12)*params(15)*y(9)*(-(1/(params(8)*y(7))));
g1(7,32)=1;
g1(7,33)=(-(1-y(18)-T(19)));
g1(7,35)=(-(params(8)*(1-T(19))));
g1(8,20)=(-y(31));
g1(8,21)=T(20);
g1(8,31)=(-y(20));
g1(9,2)=T(12)*y(31)*params(15);
g1(9,7)=y(35)*(-(params(8)*(-T(21))))+y(33)*T(21)+y(25)*T(21);
g1(9,9)=y(35)*(-(params(8)*(-(params(15)*y(7)))))+y(33)*params(15)*y(7)+y(25)*params(15)*y(7);
g1(9,25)=T(22);
g1(9,27)=(-1);
g1(9,31)=T(12)*(params(15)*y(2)-params(15)/params(8))-(-params(15))/params(8);
g1(9,33)=T(22);
g1(9,35)=(-(params(8)*(-T(22))));
g1(10,33)=1;
g1(11,3)=y(32)*(-(T(5)*params(21)*(T(9)+y(3)*y(11)*T(33))))+y(23)*(-(params(22)*y(18)*T(5)*T(6)*params(5)*params(21)*T(23)))+y(22)*(-(y(18)*T(1)*T(3)*(1-params(5))*params(21)*T(23)));
g1(11,5)=T(35);
g1(11,11)=y(32)*(-(T(5)*params(21)*y(3)*y(3)*T(33)))+y(23)*(-(params(22)*y(18)*T(5)*T(16)*params(5)*params(21)*T(36)))+y(22)*(-(y(18)*T(1)*T(17)*(1-params(5))*params(21)*T(36)))+params(23)*y(36)*(-((1-params(8)*params(16))*1/y(11)*T(24)+exp((1-params(8)*params(16))*log(y(11)))*(1-params(8)*params(16))*(-1)/(y(11)*y(11))));
g1(11,18)=y(23)*(-(params(22)*T(5)*T(16)*params(5)*params(21)*T(23)))+y(22)*(-(T(1)*T(17)*(1-params(5))*params(21)*T(23)));
g1(11,22)=(-(y(18)*T(1)*T(17)*(1-params(5))*params(21)*T(23)));
g1(11,23)=(-(params(22)*y(18)*T(5)*T(16)*params(5)*params(21)*T(23)));
g1(11,32)=(-(T(5)*params(21)*y(3)*T(9)));
g1(11,36)=1+params(23)*(-T(24));
g1(12,34)=1;
g1(13,28)=1;
g1(13,37)=1+params(23)*(-(1-params(8)*params(16)));
g1(14,35)=1;
g1(15,2)=y(30);
g1(15,3)=y(33)*(-y(17));
g1(15,15)=y(29)*(-((-((-1)/params(8)))/(y(15)*y(15))))+T(12)*y(29)*(-((1/params(8)*y(15)*y(15)-(y(15)*(1/params(8)-params(3))-(y(16)-y(15)*params(3)))*(y(15)+y(15)))/(y(15)*y(15)*y(15)*y(15))));
g1(15,16)=T(12)*y(29)*(-((-1)/(y(15)*y(15))));
g1(15,17)=y(33)*(-y(3));
g1(15,29)=T(12)*T(26)-T(25);
g1(15,30)=y(17)+y(2)-(y(17)-params(3))-(-1)/params(8)+T(12)*(-(1/params(8)));
g1(15,33)=(-(y(17)*y(3)));
g1(16,3)=y(33)*(-(1/params(22)-1));
g1(16,15)=T(12)*y(29)*(-((-1)/(y(15)*y(15))));
g1(16,23)=1;
g1(16,29)=T(12)*(-(1/y(15)));
g1(16,33)=T(27);
g1(17,2)=y(30)*(-params(19));
g1(17,3)=y(35)*(-(params(8)*(-T(28))))+y(33)*(-T(29))+y(25)*T(28)+y(24)*(-params(8));
g1(17,15)=y(33)*(-y(3));
g1(17,17)=y(35)*(-(params(8)*(-(params(19)*y(3)))))+y(33)*(-(y(3)*(-params(19))))+params(19)*y(30)+y(25)*params(19)*y(3);
g1(17,24)=(-(y(3)*params(8)));
g1(17,25)=y(3)*T(28);
g1(17,30)=T(30)+T(12)*params(19)/params(8);
g1(17,33)=(-(y(3)*T(29)));
g1(17,35)=(-(params(8)*(-(y(3)*T(28)))));
g1(18,3)=y(23)*(-(params(22)*T(5)*T(7)))+y(22)*(-(T(1)*T(4)));
g1(18,5)=y(23)*(-(params(22)*T(14)*T(2)*params(5)*params(21)*T(16)))+y(22)*(-((1-params(5))*params(21)*T(2)*T(17)*T(18)));
g1(18,7)=y(33);
g1(18,11)=y(23)*(-(params(22)*T(5)*T(16)*params(5)*params(21)*T(23)))+y(22)*(-(T(1)*T(17)*(1-params(5))*params(21)*T(23)));
g1(18,21)=1;
g1(18,22)=(-(T(1)*(1-params(5))*params(21)*T(2)*T(17)));
g1(18,23)=(-(params(22)*T(5)*T(2)*params(5)*params(21)*T(16)));
g1(18,33)=y(7);
g1(19,33)=1;
g1(19,38)=1+params(23)*(-(1-params(8)*params(16)));
g1(20,8)=(-y(31));
g1(20,20)=y(31)*(-(y(20)*(-((-((y(20)-(y(20)-1))*(y(20)+y(20))))/(y(20)*y(20)*y(20)*y(20))))-T(31)-T(31)));
g1(20,31)=T(32);
g1(20,39)=1+params(23)*(-(1-params(8)*params(16)));
g1(21,8)=T(20);
g1(21,18)=1;
g1(22,1)=1;
g1(22,3)=(-(y(18)*T(1)*T(4)));
g1(22,5)=(-(y(18)*(1-params(5))*params(21)*T(2)*T(17)*T(18)));
g1(22,11)=(-(y(18)*T(1)*T(17)*(1-params(5))*params(21)*T(23)));
g1(22,18)=(-(T(1)*(1-params(5))*params(21)*T(2)*T(17)));
g1(23,3)=(-(params(22)*y(18)*T(5)*T(7)));
g1(23,5)=(-(params(22)*y(18)*T(14)*T(2)*params(5)*params(21)*T(16)));
g1(23,11)=(-(params(22)*y(18)*T(5)*T(16)*params(5)*params(21)*T(23)));
g1(23,16)=1;
g1(23,18)=(-(params(22)*T(5)*T(2)*params(5)*params(21)*T(16)));
g1(24,3)=1-(1+(y(17)-params(3))*params(8));
g1(24,17)=(-(y(3)*params(8)));
g1(25,3)=y(17)+T(8);
g1(25,4)=1;
g1(25,7)=(-(1-T(19)));
g1(25,9)=T(22);
g1(25,17)=y(3)*T(28);
g1(26,1)=1;
g1(26,4)=(-T(11));
g1(26,5)=(-(y(4)*T(15)));
g1(27,2)=(-1);
g1(27,6)=1;
g1(27,9)=(-1);
g1(28,2)=(-1);
g1(28,13)=1;
g1(29,2)=1;
g1(29,15)=(-((y(15)*(-params(3))-(y(16)-y(15)*params(3)))/(y(15)*y(15))));
g1(29,16)=(-(1/y(15)));
g1(30,2)=y(15)-1-(y(17)-params(3))*params(19);
g1(30,15)=y(17)+y(2)-(y(17)-params(3));
g1(30,17)=T(29)+(y(2)-(y(17)-params(3)))*(-params(19))-(y(15)-1-(y(17)-params(3))*params(19));
g1(31,2)=params(15)*y(9);
g1(31,8)=(-y(20));
g1(31,9)=params(15)*y(2);
g1(31,20)=T(32);
g1(32,3)=(-(T(5)*params(21)*y(11)*T(9)));
g1(32,5)=(-(T(13)*T(14)));
g1(32,7)=1;
g1(32,11)=(-(T(5)*params(21)*y(3)*T(9)));
g1(33,3)=T(10);
g1(33,7)=(-(1-y(18)-T(19)));
g1(33,9)=T(22);
g1(33,10)=1;
g1(33,15)=(-(y(17)*y(3)));
g1(33,16)=T(27);
g1(33,17)=(-(y(3)*T(29)));
g1(33,18)=y(7);
g1(33,19)=1;
g1(34,12)=1;
g1(35,3)=(-(params(8)*(-(y(17)+T(8)))));
g1(35,4)=params(8);
g1(35,7)=(-(params(8)*(1-T(19))));
g1(35,9)=(-(params(8)*(-T(22))));
g1(35,14)=1;
g1(35,17)=(-(params(8)*(-(y(3)*T(28)))));
g1(36,11)=1-T(24);
g1(37,13)=1-(1-params(8)*params(16));
g1(38,19)=1-(1-params(8)*params(16));
g1(39,20)=1-(1-params(8)*params(16));
if ~isreal(g1)
    g1 = real(g1)+2*imag(g1);
end
end
