function T = static_g1_tt(T, y, x, params)
% function T = static_g1_tt(T, y, x, params)
%
% File created by Dynare Preprocessor from .mod file
%
% Inputs:
%   T         [#temp variables by 1]  double   vector of temporary terms to be filled by function
%   y         [M_.endo_nbr by 1]      double   vector of endogenous variables in declaration order
%   x         [M_.exo_nbr by 1]       double   vector of exogenous variables in declaration order
%   params    [M_.param_nbr by 1]     double   vector of parameter values in declaration order
%
% Output:
%   T         [#temp variables by 1]  double   vector of temporary terms
%

assert(length(T) >= 36);

T = RANK_q4.static_resid_tt(T, y, x, params);

T(33) = getPowerDeriv(y(11)*y(3),params(5),2);
T(34) = getPowerDeriv(y(5),1-params(5),2);
T(35) = y(32)*(-(T(14)*params(21)*y(3)*T(9)))+y(23)*(-(params(22)*y(18)*T(14)*T(16)*params(5)*params(21)*T(23)))+y(22)*(-(y(18)*T(18)*T(17)*(1-params(5))*params(21)*T(23)));
T(36) = getPowerDeriv(y(11),params(5),2);

end
