function residual = static_resid(T, y, x, params, T_flag)
% function residual = static_resid(T, y, x, params, T_flag)
%
% File created by Dynare Preprocessor from .mod file
%
% Inputs:
%   T         [#temp variables by 1]  double   vector of temporary terms to be filled by function
%   y         [M_.endo_nbr by 1]      double   vector of endogenous variables in declaration order
%   x         [M_.exo_nbr by 1]       double   vector of exogenous variables in declaration order
%   params    [M_.param_nbr by 1]     double   vector of parameter values in declaration order
%                                              to evaluate the model
%   T_flag    boolean                 boolean  flag saying whether or not to calculate temporary terms
%
% Output:
%   residual
%

if T_flag
    T = RANK_q4.static_resid_tt(T, y, x, params);
end
residual = zeros(39, 1);
residual(1) = y(22)+y(26);
residual(2) = y(31)*params(15)*y(9)+(y(15)-1-(y(17)-params(3))*params(19))*y(30)+y(29)+(-y(28))-y(27);
residual(3) = y(24)+params(23)*y(22)*(-(y(18)*T(1)*T(4)))+params(23)*y(23)*(-(params(22)*y(18)*T(5)*T(7)))+params(23)*y(24)*(-(1+(y(17)-params(3))*params(8)))+params(23)*y(25)*(y(17)+T(8))+params(23)*y(32)*(-(T(5)*params(21)*y(11)*T(9)))+params(23)*y(33)*T(10)+params(23)*y(35)*(-(params(8)*(-(y(17)+T(8)))));
residual(4) = 1/y(4)+params(8)*y(35)+y(28)*(-(params(8)*y(4)))/(params(8)*y(4)*params(8)*y(4))+y(25)+y(26)*(-T(11))+T(12)*y(28)*1/(params(8)*y(4));
residual(5) = y(32)*(-(T(13)*T(14)))+y(26)*(-(y(4)*T(15)))+y(23)*(-(params(22)*y(18)*T(14)*T(2)*params(5)*params(21)*T(16)))+y(22)*(-(y(18)*(1-params(5))*params(21)*T(2)*T(17)*T(18)))-params(11)*getPowerDeriv(y(5),1+params(10),1)/(1+params(10));
residual(6) = y(27);
residual(7) = y(35)*(-(params(8)*(1-T(19))))+y(33)*(-(1-y(18)-T(19)))+y(32)+y(31)*params(15)*y(9)*(-((-(params(8)*y(7)))/(params(8)*y(7)*params(8)*y(7))))+y(25)*(-(1-T(19)))+T(12)*y(31)*params(15)*y(9)*(-(1/(params(8)*y(7))));
residual(8) = y(31)*(-y(20))+y(21)*T(20);
residual(9) = y(35)*(-(params(8)*(-T(22))))+y(33)*T(22)+y(31)*(-((-params(15))/params(8)))+y(25)*T(22)-y(27)+T(12)*y(31)*(params(15)*y(2)-params(15)/params(8));
residual(10) = y(33);
residual(11) = y(36)+y(32)*(-(T(5)*params(21)*y(3)*T(9)))+y(23)*(-(params(22)*y(18)*T(5)*T(16)*params(5)*params(21)*T(23)))+y(22)*(-(y(18)*T(1)*T(17)*(1-params(5))*params(21)*T(23)))+params(23)*y(36)*(-T(24));
residual(12) = y(34);
residual(13) = y(37)+y(28)+params(23)*y(37)*(-(1-params(8)*params(16)));
residual(14) = y(35);
residual(15) = y(33)*(-(y(17)*y(3)))+y(30)*(y(17)+y(2)-(y(17)-params(3))-(-1)/params(8))+y(29)*(-T(25))+T(12)*y(29)*T(26)+T(12)*y(30)*(-(1/params(8)));
residual(16) = y(33)*T(27)+y(23)+T(12)*y(29)*(-(1/y(15)));
residual(17) = y(35)*(-(params(8)*(-(y(3)*T(28)))))+y(33)*(-(y(3)*T(29)))+y(30)*T(30)+y(25)*y(3)*T(28)+y(24)*(-(y(3)*params(8)))+T(12)*y(30)*params(19)/params(8);
residual(18) = y(33)*y(7)+y(23)*(-(params(22)*T(5)*T(2)*params(5)*params(21)*T(16)))+y(21)+y(22)*(-(T(1)*(1-params(5))*params(21)*T(2)*T(17)));
residual(19) = y(38)+y(33)+params(23)*(-(1-params(8)*params(16)))*y(38);
residual(20) = y(39)+y(31)*T(32)+params(23)*(-(1-params(8)*params(16)))*y(39);
residual(21) = y(18)-y(8)/((params(12)-1)/params(12));
residual(22) = y(1)-y(18)*T(1)*(1-params(5))*params(21)*T(2)*T(17);
residual(23) = y(16)-params(22)*y(18)*T(5)*T(2)*params(5)*params(21)*T(16);
residual(24) = y(3)-(y(3)+params(8)*(y(17)-params(3))*y(3));
residual(25) = y(4)-(y(7)-(y(3)*(y(17)+T(8))+T(19)*y(7)));
residual(26) = y(1)-y(4)*T(11);
residual(27) = y(6)-(y(9)+y(2));
residual(28) = (-(y(2)-y(13)));
residual(29) = y(2)-(y(16)-y(15)*params(3))/y(15);
residual(30) = y(15)*y(17)-y(17)-T(8)+(y(15)-1-(y(17)-params(3))*params(19))*(y(2)-(y(17)-params(3)));
residual(31) = params(15)*y(9)*y(2)-y(20)*(y(8)-(y(20)-1)/y(20));
residual(32) = y(7)-T(5)*T(13);
residual(33) = y(10)-((1-y(18))*y(7)-T(19)*y(7)-y(19)+y(3)*(y(15)*y(17)-y(17)-T(8))+y(3)*(y(16)/params(22)-y(16)));
residual(34) = y(12);
residual(35) = y(14)-params(8)*(y(7)-(y(3)*(y(17)+T(8))+T(19)*y(7))-y(4));
residual(36) = y(11)-exp((1-params(8)*params(16))*log(y(11)));
residual(37) = y(13)-((1-params(8)*params(16))*y(13)+params(8)*params(16)*params(2));
residual(38) = y(19)-(1-params(8)*params(16))*y(19);
residual(39) = y(20)-(y(20)*(1-params(8)*params(16))+params(12)*params(8)*params(16));
if ~isreal(residual)
  residual = real(residual)+imag(residual).^2;
end
end
